get_filename_component(PROJECT_CMAKE_DIR "${CMAKE_CURRENT_LIST_FILE}" PATH)
set(cilantro_INCLUDE_DIRS "${PROJECT_CMAKE_DIR}/../../../include;")

# Library dependencies (contains definitions for IMPORTED targets)
if(NOT TARGET cilantro AND NOT cilantro_BINARY_DIR)
    include("${PROJECT_CMAKE_DIR}/cilantroTargets.cmake")
    
    include(CMakeFindDependencyMacro)
    find_package(Eigen3)
    if(NOT TARGET Eigen3::Eigen)
        message("Eigen has buggy exported package, but headers are found: ${EIGEN3_INCLUDE_DIRS}. Applying workaround.")
        add_library(Eigen INTERFACE IMPORTED GLOBAL)
        target_include_directories(Eigen INTERFACE "${EIGEN3_INCLUDE_DIRS}")
        add_library(Eigen3::Eigen ALIAS Eigen)
    endif()
    
    
endif()

set(cilantro_LIBRARIES cilantro)
